## k2pdfopt 2.51+ds

=== CMakeLists.txt ===
project(k2pdfopt C)
cmake_minimum_required(VERSION 2.6)

# ---- Test for packages

include(FindPkgConfig)

set(K2PDFOPT_LIB "-lm")

# cmake -DCMAKE_BUILD_TYPE=Debug <path>

# TODO: configure flavour with opions
## 
## option (USE_MUPDF
## 	"Use muPDF libraries" OFF)
## option (USE_GHOSTSCRIPT
## 	"Use Ghostscript executable" ON)
## option (USE_DJVU
## 	"" OFF)
## eoption (USE_GOCR
## 	"" OFF)
## option (USE_LEPTONICA
## 	"" OFF)
## option (USE_TESSERACT
## 	"" OFF)
## option (USE_JASPER
## 	"" OFF)
## option (USE_GSL
## 	"" OFF)

# HAVE_K2GUI

include(FindZLIB)
if(ZLIB_FOUND)
  set(HAVE_Z_LIB 1)
# include_directories(${ZLIB_INCLUDE_DIRS})
  set(K2PDFOPT_LIB ${K2PDFOPT_LIB} ${ZLIB_LIBRARY})
endif(ZLIB_FOUND)

include(FindPNG)
if(PNG_FOUND)
  set(HAVE_PNG_LIB 1)
  set(K2PDFOPT_LIB ${K2PDFOPT_LIB} ${PNG_LIBRARY_RELEASE})
endif(PNG_FOUND)

include(FindJPEG)
if(JPEG_FOUND)
  set(HAVE_JPEG_LIB 1)
  set(K2PDFOPT_LIB ${K2PDFOPT_LIB} ${JPEG_LIBRARY})
endif(JPEG_FOUND)

include(FindJasper)
if(JASPER_FOUND)
  set(HAVE_JASPER_LIB 1)
endif(JASPER_FOUND)

# paths from willuslib/wgs.c
find_program(GHOSTSCRIPT_EXECUTABLE gs
#  PATHS /usr/bin /usr/share/gs /usr/local/gs /opt/gs 
#    /usr/share/gs* /usr/local/gs* /opt/gs*
)
if(GHOSTSCRIPT_EXECUTABLE)
  set(HAVE_GHOSTSCRIPT 1)
  message(STATUS "Found ghostscript executable")
else()
  message(STATUS "Could NOT find ghostscript executable")
endif(GHOSTSCRIPT_EXECUTABLE)

# willus.h
# HAVE_GSL_LIB


# libfreetype6 (>= 2.3.9), libjbig2dec0, libjpeg8 (>= 8c), libx11-6, libxext6, zlib1g (>= 1:1.2.0)
# MUPDF_STATIC_LDFLAGS misses mupdf-js-none, and doubles libs ...

pkg_check_modules(MUPDF mupdf)
if(MUPDF_FOUND)
  set(HAVE_MUPDF_LIB 1) 
  # (includes jbig2dec, openjpeg, freetype)
  include_directories(SYSTEM ${MUPDF_INCLUDEDIR})
  message(STATUS "mupdf libraries: ${MUPDF_LDFLAGS}")
  set(K2PDFOPT_LIB ${K2PDFOPT_LIB} ${MUPDF_LDFLAGS} 
    -lmupdf-js-none -lopenjpeg -ljbig2dec -ljpeg -lfreetype
  )
endif(MUPDF_FOUND)

pkg_check_modules(DJVU ddjvuapi)
if(DJVU_FOUND)
  set(HAVE_DJVU_LIB 1)
  include_directories(SYSTEM ${DJVU_INCLUDEDIR})
  set(K2PDFOPT_LIB ${K2PDFOPT_LIB} ${DJVU_LDFLAGS})
endif(DJVU_FOUND)

# HAVE_GOCR_LIB
# HAVE_LEPTONICA_LIB
# HAVE_TESSERACT_LIB

# ---- Describe project

SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DUSE_CMAKE -Wall")

include_directories(. willuslib k2pdfoptlib)

configure_file (
  "${PROJECT_SOURCE_DIR}/config.h.in"
  "${PROJECT_BINARY_DIR}/config.h"
)

add_subdirectory(willuslib)
add_subdirectory(k2pdfoptlib)

# ms
add_executable(k2pdfopt k2pdfopt.c)
target_link_libraries (k2pdfopt k2pdfoptlib willuslib ${K2PDFOPT_LIB})


message("")
message("-- Summary --")
message("")
message("General:")
message("	C-flags:	'${CMAKE_C_FLAGS}' (-DCMAKE_C_FLAGS=\"...\")")
message("	Build type:	${CMAKE_BUILD_TYPE} (-DCMAKE_BUILD_TYPE=\"...\")")
message("")
message("Install:")
message("	Prefix:		'${CMAKE_INSTALL_PREFIX}' (-DCMAKE_INSTALL_PREFIX=...)")
message("	Doc path:	'${DOC_PATH}' (-DDOC_PATH=...)")
message("")

=== k2pdfoptlib/CMakeLists.txt ===
project(k2pdfopt C)
cmake_minimum_required(VERSION 2.6)

include_directories(..)

add_library(k2pdfoptlib
	bmpregion.c  k2gui_cbox.c  k2ocr.c   k2sys.c textwords.c
	devprofile.c k2gui_osdep.c k2parsecmd.c  k2usage.c  userinput.c
	k2bmp.c  k2mark.c  k2proc.c  k2version.c wrapbmp.c
	k2file.c  k2master.c k2publish.c  pagelist.c
	k2files.c k2mem.c k2settings.c  pageregions.c
	k2menu.c  k2settings2cmd.c textrows.c
	
)

# k2gui.c

=== willuslib/CMakeLists.txt ===
project(k2pdfopt C)
cmake_minimum_required(VERSION 2.6)

include_directories(..)

set(WILLUSLIB_SRC
    ansi.c array.c bmp.c bmpdjvu.c bmpmupdf.c dtcompress.c filelist.c
    fontdata.c fontrender.c gslpolyfit.c linux.c math.c mem.c ocr.c
    ocrjocr.c ocrtess.c pdfwrite.c point2d.c render.c strbuf.c string.c
    token.c wfile.c wgs.c wgui.c willusversion.c win.c winbmp.c
    wincomdlg.c winmbox.c winshell.c wmupdf.c wmupdfinfo.c wpdf.c wsys.c
    wzfile.c wleptonica.c
)
# ocr.c  
# win.c  winbmp.c winmbox.c wincomdlg.c wgui.c winshell.c

if(DJVU_FOUND)
  set(WILLUSLIB_SRC ${WILLUSLIB_SRC} bmpdjvu.c)
endif(DJVU_FOUND)

if(MUPDF_FOUND)
  set(WILLUSLIB_SRC ${WILLUSLIB_SRC} bmpmupdf.c wmupdf.c)
endif(MUPDF_FOUND)

message("-- Willuslib sources: ${WILLUSLIB_SRC}")

add_library(willuslib ${WILLUSLIB_SRC})

# HAVE_GOCR_LIB: ocrjocr.c
# HAVE_TESSERACT_LIB: ocrtess.c

=== debian/changelog ===
k2pdfopt (2.51+ds-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.3.0
  * Bump debhelper compat to 12

 -- Yangfl <mmyangfl@gmail.com>  Mon, 07 Jan 2019 16:42:26 +0800

k2pdfopt (2.42+ds-1) unstable; urgency=medium

  * Initial release (Closes: #858606)

 -- Yangfl <mmyangfl@gmail.com>  Fri, 09 Mar 2018 15:22:29 +0800

=== debian/control ===
Source: k2pdfopt
Section: utils
Priority: optional
Maintainer: Yangfl <mmyangfl@gmail.com>
Build-Depends:
 debhelper (>= 12~),
 cmake,
 pkg-config,
 zlib1g-dev,
 libpng-dev,
 libjpeg-dev,
 libturbojpeg0-dev,
 libfreetype6-dev,
 libopenjp2-7-dev,
 libdjvulibre-dev,
 libleptonica-dev,
# libmupdf-dev,
Standards-Version: 4.3.0
Homepage: http://www.willus.com/k2pdfopt/

Package: k2pdfopt
Architecture: any
Depends:
 ghostscript,
 ${shlibs:Depends},
 ${misc:Depends},
Description: PDF Reflow tool
 K2pdfopt optimizes PDF/DJVU files for mobile e-readers (e.g. the Kindle) and
 smartphones. It works well on multi-column PDF/DJVU files and can re-flow text
 even on scanned PDF files. It can also be used as a general PDF copying/
 cropping/re-sizing/OCR-ing manipulation tool. It can generate native or
 bitmapped PDF output, with an optional OCR layer.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@

=== debian/watch ===
version=4
opts=dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$//,repacksuffix=+ds \
http://www.willus.com/k2pdfopt/src/ \
  k2pdfopt_v([\d\.]+.?)_src\.zip debian uupdate

## k2pdfopt 2.52+ds

=== debian/changelog ===
k2pdfopt (2.52+ds-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.5.0
  * Bump debhelper compat to 13
  * Add upstream metadata

 -- Yangfl <mmyangfl@gmail.com>  Sun, 14 Jun 2020 12:07:32 +0800

## k2pdfopt 2.53%2Bds

=== debian/changelog ===
k2pdfopt (2.53+ds-1build1) jammy; urgency=medium

  * No-change rebuild against libgsl27

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 07 Dec 2021 17:33:13 +0000

k2pdfopt (2.53+ds-1) unstable; urgency=medium

  * New upstream release

 -- Yangfl <mmyangfl@gmail.com>  Wed, 26 Aug 2020 23:01:41 +0800

## k2pdfopt 2.53+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,9 @@
 project(k2pdfopt C)
 cmake_minimum_required(VERSION 2.6)
 
+#
+# Last modified by Q.P. Hou 8 June 2019
+#
 # ---- Test for packages
 
 include(FindPkgConfig)
@@ -41,6 +44,8 @@
 if(PNG_FOUND)
   set(HAVE_PNG_LIB 1)
   set(K2PDFOPT_LIB ${K2PDFOPT_LIB} ${PNG_LIBRARY_RELEASE})
+else(PNG_FOUND)
+  message( FATAL_ERROR "Missing required dependency libpng." )
 endif(PNG_FOUND)
 
 include(FindJPEG)
@@ -92,14 +97,26 @@
 endif(DJVU_FOUND)
 
 # HAVE_GOCR_LIB
-# HAVE_LEPTONICA_LIB
-# HAVE_TESSERACT_LIB
+
+pkg_check_modules(LEPT lept)
+if(LEPT_FOUND)
+  set(HAVE_LEPTONICA_LIB 1)
+  set(K2PDFOPT_LIB ${K2PDFOPT_LIB} ${LEPT_LDFLAGS})
+  include_directories(SYSTEM ${LEPT_INCLUDEDIR})
+endif(LEPT_FOUND)
+
+pkg_check_modules(TESSERACT tesseract)
+if(TESSERACT_FOUND)
+  set(HAVE_TESSERACT_LIB 1)
+  set(K2PDFOPT_LIB ${K2PDFOPT_LIB} ${TESSERACT_LDFLAGS})
+  include_directories(SYSTEM ${TESSERACT_INCLUDEDIR})
+endif(TESSERACT_FOUND)
 
 # ---- Describe project
 
 SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DUSE_CMAKE -Wall")
 
-include_directories(. willuslib k2pdfoptlib)
+include_directories(. "${PROJECT_BINARY_DIR}" willuslib k2pdfoptlib)
 
 configure_file (
   "${PROJECT_SOURCE_DIR}/config.h.in"
@@ -111,7 +128,7 @@
 
 # ms
 add_executable(k2pdfopt k2pdfopt.c)
-target_link_libraries (k2pdfopt k2pdfoptlib willuslib ${K2PDFOPT_LIB})
+target_link_libraries (k2pdfopt k2pdfoptlib willuslib ${K2PDFOPT_LIB} pthread)
 
 
 message("")

=== willuslib/CMakeLists.txt ===
--- 
+++ 
@@ -1,15 +1,18 @@
 project(k2pdfopt C)
 cmake_minimum_required(VERSION 2.6)
+#
+# Last update 31 May 2020 willus.com
+#
 
 include_directories(..)
 
 set(WILLUSLIB_SRC
     ansi.c array.c bmp.c bmpdjvu.c bmpmupdf.c dtcompress.c filelist.c
     fontdata.c fontrender.c gslpolyfit.c linux.c math.c mem.c ocr.c
-    ocrjocr.c ocrtess.c pdfwrite.c point2d.c render.c strbuf.c string.c
+    ocrgocr.c ocrtess.c pdfwrite.c point2d.c render.c strbuf.c string.c
     token.c wfile.c wgs.c wgui.c willusversion.c win.c winbmp.c
-    wincomdlg.c winmbox.c winshell.c wmupdf.c wmupdfinfo.c wpdf.c wsys.c
-    wzfile.c wleptonica.c
+    wincomdlg.c wininet.c winmbox.c winshell.c winshellwapi.c
+    wleptonica.c wmupdf.c wmupdfinfo.c wpdf.c wsys.c wzfile.c
 )
 # ocr.c  
 # win.c  winbmp.c winmbox.c wincomdlg.c wgui.c winshell.c

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Yangfl <mmyangfl@gmail.com>
 Build-Depends:
- debhelper (>= 12~),
+ debhelper-compat (= 13),
  cmake,
  pkg-config,
  zlib1g-dev,
@@ -14,9 +14,13 @@
  libopenjp2-7-dev,
  libdjvulibre-dev,
  libleptonica-dev,
+ libgsl-dev,
 # libmupdf-dev,
-Standards-Version: 4.3.0
+Rules-Requires-Root: no
+Standards-Version: 4.5.0
 Homepage: http://www.willus.com/k2pdfopt/
+Vcs-Git: https://salsa.debian.org/yangfl-guest/k2pdfopt.git
+Vcs-Browser: https://salsa.debian.org/yangfl-guest/k2pdfopt
 
 Package: k2pdfopt
 Architecture: any

## k2pdfopt 2.54+ds

=== willuslib/CMakeLists.txt ===
--- 
+++ 
@@ -9,10 +9,11 @@
 set(WILLUSLIB_SRC
     ansi.c array.c bmp.c bmpdjvu.c bmpmupdf.c dtcompress.c filelist.c
     fontdata.c fontrender.c gslpolyfit.c linux.c math.c mem.c ocr.c
-    ocrgocr.c ocrtess.c pdfwrite.c point2d.c render.c strbuf.c string.c
-    token.c wfile.c wgs.c wgui.c willusversion.c win.c winbmp.c
-    wincomdlg.c wininet.c winmbox.c winshell.c winshellwapi.c
-    wleptonica.c wmupdf.c wmupdfinfo.c wpdf.c wsys.c wzfile.c
+    ocrgocr.c ocrtess.c ocrwords.c pdffonts.c pdfwrite.c point2d.c
+    render.c strbuf.c string.c token.c wfile.c wgs.c wgui.c
+    willusversion.c win.c winbmp.c wincomdlg.c wininet.c winmbox.c
+    winshell.c winshellwapi.c wleptonica.c wmupdf.c wmupdfinfo.c wpdf.c
+    wsys.c wzfile.c
 )
 # ocr.c  
 # win.c  winbmp.c winmbox.c wincomdlg.c wgui.c winshell.c

=== debian/changelog ===
k2pdfopt (2.54+ds-1) unstable; urgency=medium

  * New upstream release
  * Workaround buggy PDF page counter (Closes: #945008)
  * Bump Standards-Version to 4.6.2

 -- Yangfl <mmyangfl@gmail.com>  Fri, 20 Jan 2023 19:01:03 +0800

=== debian/control ===
--- 
+++ 
@@ -10,15 +10,15 @@
  libpng-dev,
  libjpeg-dev,
  libturbojpeg0-dev,
- libfreetype6-dev,
+ libfreetype-dev,
  libopenjp2-7-dev,
  libdjvulibre-dev,
  libleptonica-dev,
  libgsl-dev,
 # libmupdf-dev,
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
-Homepage: http://www.willus.com/k2pdfopt/
+Standards-Version: 4.6.2
+Homepage: https://www.willus.com/k2pdfopt/
 Vcs-Git: https://salsa.debian.org/yangfl-guest/k2pdfopt.git
 Vcs-Browser: https://salsa.debian.org/yangfl-guest/k2pdfopt

## k2pdfopt 2.55%2Bds

=== debian/watch ===
version=4
opts=dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$//,repacksuffix=+ds \
https://www.willus.com/k2pdfopt/src/ \
  k2pdfopt_v([\d\.]+.?)_src\.zip debian uupdate

## k2pdfopt 2.55%2bds

=== debian/watch ===
Version: 5
Source: https://www.willus.com/k2pdfopt/src/
Matching-Pattern: k2pdfopt_v([\d\.]+.?)_src\.zip
Dversion-Mangle: auto
Repacksuffix: +ds

## k2pdfopt 2.55+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -85,7 +85,7 @@
   include_directories(SYSTEM ${MUPDF_INCLUDEDIR})
   message(STATUS "mupdf libraries: ${MUPDF_LDFLAGS}")
   set(K2PDFOPT_LIB ${K2PDFOPT_LIB} ${MUPDF_LDFLAGS} 
-    -lmupdf-js-none -lopenjpeg -ljbig2dec -ljpeg -lfreetype
+    -lmupdf-js-none -lopenjpeg -ljbig2dec -ljpeg -lfreetype -llcms -lgumbo
   )
 endif(MUPDF_FOUND)

=== k2pdfoptlib/CMakeLists.txt ===
project(k2pdfopt C)
cmake_minimum_required(VERSION 2.6)

include_directories(..)

add_library(k2pdfoptlib
	bmpregion.c devprofile.c k2bmp.c k2file.c k2files.c k2gui_cbox.c
	k2gui_osdep.c k2mark.c k2master.c k2mem.c k2menu.c k2ocr.c
	k2parsecmd.c k2proc.c k2publish.c k2settings.c k2settings2cmd.c
	k2sys.c k2usage.c k2version.c pagelist.c pageregions.c textrows.c
	textwords.c userinput.c wrapbmp.c
)

# k2gui.c k2gui_overlay.c

=== willuslib/CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,7 @@
     render.c strbuf.c string.c token.c wfile.c wgs.c wgui.c
     willusversion.c win.c winbmp.c wincomdlg.c wininet.c winmbox.c
     winshell.c winshellwapi.c wleptonica.c wmupdf.c wmupdfinfo.c wpdf.c
-    wsys.c wzfile.c
+    wpdfoutline.c wpdfutil.c wsys.c wzfile.c
 )
 # ocr.c  
 # win.c  winbmp.c winmbox.c wincomdlg.c wgui.c winshell.c

=== debian/changelog ===
k2pdfopt (2.55+ds-4) unstable; urgency=medium

  * Fix FTBFS with CMake 4 (Closes: #1113066)
  * Bump Standards-Version to 4.7.2

 -- Yangfl <mmyangfl@gmail.com>  Sun, 14 Sep 2025 13:26:43 +0800

k2pdfopt (2.55+ds-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Leptonlib transition.

 -- Jeff Breidenbach <jab@debian.org>  Sat, 05 Oct 2024 02:59:43 +0000

k2pdfopt (2.55+ds-3) unstable; urgency=medium

  * Build with mupdf (Closes: #935297)
  * Bump Standards-Version to 4.7.0

 -- Yangfl <mmyangfl@gmail.com>  Tue, 28 May 2024 01:49:28 +0800

k2pdfopt (2.55+ds-2) unstable; urgency=medium

  * Fix FTBFS (Closes: #1066717)

 -- Yangfl <mmyangfl@gmail.com>  Thu, 21 Mar 2024 14:02:18 +0800

k2pdfopt (2.55+ds-1) unstable; urgency=medium

  * New upstream release

 -- Yangfl <mmyangfl@gmail.com>  Tue, 06 Feb 2024 22:34:42 +0800

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
- pkg-config,
+ pkgconf,
  zlib1g-dev,
  libpng-dev,
  libjpeg-dev,
@@ -15,9 +15,13 @@
  libdjvulibre-dev,
  libleptonica-dev,
  libgsl-dev,
-# libmupdf-dev,
+ libmupdf-dev,
+ libgumbo-dev,
+ libmujs-dev,
+ libjbig2dec0-dev,
+ libharfbuzz-dev,
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://www.willus.com/k2pdfopt/
 Vcs-Git: https://salsa.debian.org/yangfl-guest/k2pdfopt.git
 Vcs-Browser: https://salsa.debian.org/yangfl-guest/k2pdfopt

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND =


%:
	dh $@
